SystemOrganization addCategory: #'Xpf-Multipoint-Plugin'!

SmartSyntaxInterpreterPlugin subclass: #MultiPointerPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'SR 4/22/2009 14:07'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^ true! !

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'SR 4/22/2009 14:08'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^ true! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 14:28'!
initialiseModule
	"Initialise the module"
	self export: true.
	^self cCode: 'multiPointerInit()' inSmalltalk:[true]! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 13:23'!
moduleUnloaded: aModuleName 
	"The module with the given name was just unloaded. 
	Make sure we have no dangling references."
	self export: true.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/22/2009 14:28'!
primitiveMultiPointerCount

	| r |
	self primitive: 'primitiveMultiPointerCount'.
	r := self cCode:' multiPointerCount()'.
	^r asOop: SmallInteger! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/29/2009 16:40'!
primitiveMultiPointerCurrentState: aPointerID with: aMultiPointerState

	|  inputX inputY buttons |
	self primitive:'primitiveMultiPointerCurrentState'.
	self var: #inputX declareC: 'int inputX'.
	self var: #inputY declareC: 'int inputY'.
	self var: #buttons declareC: 'int buttons'.
	self cCode: 'multiPointerCurrentState(interpreterProxy->integerValueOf(aPointerID), &inputX, &inputY, &buttons)'.
	interpreterProxy storeInteger: 0 ofObject: aMultiPointerState withValue: inputX.
	interpreterProxy storeInteger: 1 ofObject: aMultiPointerState withValue: inputY.
	interpreterProxy storeInteger: 2 ofObject: aMultiPointerState withValue: buttons.
	^ aMultiPointerState! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/29/2009 19:12'!
primitiveMultiPointerDeviceSemaphoreHandle: aSemaIndex

	| |
	self primitive:'primitiveMultiPointerDeviceSemaphoreHandle' parameters: #(#SmallInteger).
	self multiPointerSetDeviceSemaphore: aSemaIndex.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/29/2009 19:11'!
primitiveMultiPointerEventSemaphoreHandle: aSemaIndex

	| |
	self primitive:'primitiveMultiPointerEventSemaphoreHandle' parameters: #(#SmallInteger).
	self multiPointerSetEventSemaphore: aSemaIndex.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/29/2009 13:59'!
primitiveMultiPointerLively: aPointerID

	| result |
	self primitive:'primitiveMultiPointerLively'.
	result := self multiPointerLively: (interpreterProxy integerValueOf: aPointerID).
	^result asOop: SmallInteger! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/29/2009 11:55'!
primitiveMultiPointerName: aPointerID

	| oop length buffer |
	self primitive:'primitiveMultiPointerName'.
	length := self multiPointerNameLength:  (interpreterProxy integerValueOf: aPointerID).
	oop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: length.
	buffer :=  interpreterProxy firstIndexableField: oop.
	self cCode: 'multiPointerName(interpreterProxy->integerValueOf(aPointerID), length, buffer)'.
	^ oop! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 5/2/2009 14:55'!
primitiveMultiPointerUseHardwareMouse

	| |
	self primitive:'primitiveMultiPointerUseHardwareMouse'.
	self multiPointerUseHardwareMouse.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 5/2/2009 14:56'!
primitiveMultiPointerUseSoftwareMouse

	| |
	self primitive:'primitiveMultiPointerUseSoftwareMouse'.
	self multiPointerUseSoftwareMouse.! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 14:28'!
shutdownModule
	"Initialise the module"
	self export: true.
	^self cCode: 'multiPointerShutdown()' inSmalltalk:[true]! !
